/**

  Spago4Q - The Business Intelligence Free Platform

  Copyright (C) 2009 Engineering Ingegneria Informatica S.p.A.

  Spago4Q is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  Spago4Q is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

 **/
package it.eng.spago4q.extractors.clearquest;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;


/**
 * Classe per l'esecuzione di query in ClearQuest 
 * utilizzando le API perl. La classe CQWrapper
 * permette di connettersi ad un socket perl di
 * tipo tcp ed inviare una richiesta opportunamente
 * formattata in xml.
 * La risposta sar anch'essa restituita in formato
 * xml.
 */

public class CQWrapperSSHQuery {
	
	static String host;
	
	/**
	 * Il metodo setHost imposta l'host name della connessione.
	 * @param hostName : l'indirizzo dell'host su cui aprire la connessione
	 */
	public void setHost(String hostName){
		host = hostName;
	}
	/**
	 * Costruttore della classe. Imposta di default i valori host=localhost.
	 */
	public CQWrapperSSHQuery(){
		host = "localhost";
	}
	/**
	 * Richiede l'esecuzione di una query su ClearQuest.
	 * @param xml : parametri della query
	 * @return una stringa formattata in xml contenente la risposta o la stringa vuota se non ci sono elementi.
	 * @throws IOException
	 * @throws InterruptedException
	 */
	public String getQueryResult(String xml) throws IOException,InterruptedException {
		
		String queryResult = "";
		String perl = "/opt/rational/clearquest/bin/cqperl";
		String fileName = "/opt/nexen/getQueries.pl";
		String cmd = "ssh spago4q@" + host + " " + perl + " " + fileName + " '" + xml + "'";
		Process p = Runtime.getRuntime().exec(cmd);
		BufferedReader err = new BufferedReader(new InputStreamReader(p.getErrorStream()));
		String line;
		while((line = err.readLine()) != null) {
			System.out.println("Read from error stream: \"" + line + "\"");
		}
		BufferedReader input = new BufferedReader(new InputStreamReader(p.getInputStream()));
		while((line = input.readLine()) != null) {
			//System.out.println("Read from output stream: \"" + line + "\"");
			queryResult = queryResult + "\n" + line;
		}
        return queryResult;
	}
}
 