/**

  Spago4Q - The Business Intelligence Free Platform

  Copyright (C) 2009 Engineering Ingegneria Informatica S.p.A.

  Spago4Q is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  Spago4Q is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

 **/
package it.eng.spago4q.extractors.clearquest;

import java.io.IOException;

public class WrapperTesterSSH {

	/**
	 * Metodo di test per il CQWrapper
	 * 
	 * @param args
	 *            : nessuno
	 */
	public static void main(String[] args) {

		// Esempi di
		// String problem =
		// "<entities><entity name=\"Problem\"><attribute name=\"id\"/><attribute name=\"Urgency\"/><attribute name=\"SubmitDate\"/><attribute name=\"FoundInRelease\"/><attribute name=\"FoundInPhase\"/><attribute name=\"Severity\"/><attribute name=\"System\"/><attribute name=\"Version\"/><attribute name=\"Call\" reflist=\"yes\"/><attribute name=\"State\"/><attribute name=\"ChangeRequest\" reflist=\"list\"/><attribute name=\"LastUpdate\"/><attribute name=\"ClosureDate\"/></entity></entities>\n";
		// String risk =
		// "<entities><entity name=\"Risk\"><attribute name=\"id\"/><attribute name=\"EffectiveResolutionDate\"/><attribute name=\"TargetResolutionDate\"/><attribute name=\"MitigationActions\" reflist=\"yes\"/><attribute name=\"Standing\"/><attribute name=\"Typology\"/><attribute name=\"System\"/><attribute name=\"Probability\"/><attribute name=\"Impact\"/><attribute name=\"Typology_subcat\"/><attribute name=\"LastUpdate\"/></entity></entities>\n";
		String systems = "<entities>" +
				"<entity name=\"Systems\">" +
				"<attribute name=\"Short_name\"/>" +
				"</entity>" +
				"</entities>";
		// String workOrder =
		// "<entities><entity name=\"Work_Order\"><attribute name=\"id\"/><attribute name=\"WorkOfferRejectDate\"/><attribute name=\"WorkOfferAcceptDate\"/><attribute name=\"SLARespected\"/><attribute name=\"RequestFormSendDate\"/><attribute name=\"WorkOfferSendDate\"/><attribute name=\"System\"/><attribute name=\"Type\"/><attribute name=\"WOId\"/><attribute name=\"PlannedDeliveryDate\"/><attribute name=\"FirstDeliveryDate\"/><attribute name=\"LastUpdate\"/><attribute name=\"LastDeliveryDate\"/></entity></entities>\n";
		String actionKpi = "<entities> " +
				"<entity name=\"ActionKPI\"> " +
				"<attribute name=\"id\" /> " +
				"<attribute name=\"KPI\" /> " +
				"<attribute name=\"title\" /> " +
				"<attribute name=\"Description\" /> " +
				"<attribute name=\"NumKPI\" /> " +
				"<attribute name=\"ApplicationDate\" > " +
//				"<filter operation=\"BETWEEN\" value=\"2009-11-29 11:00:00 , 2009-12-31 11:00:00\" />" +
				"<filter operation=\"GTE\" value=\"2009-11-29 11:00:00\" />" +
				"<filter operation=\"LTE\" value=\"2009-12-31 11:00:00\" />" +
				"</attribute>" +
				"</entity> " +
				"</entities>";
		try {
			CQWrapperSSH wrapper = new CQWrapperSSH();

			// Definizione parametri di connessione (Opzionale)
			wrapper.setHost("161.27.204.80");

			// String problemOut = wrapper.getQueryResult(problem);
			// String sysOut = wrapper.getQueryResult(systems);
			String sysOut = wrapper.getQueryResult(actionKpi);
			// String workOrderOut = wrapper.getQueryResult(workOrder);
			// System.out.println ("PROBLEM:");
			// System.out.println (problemOut);
			System.out.println("Systems:");
			System.out.println(sysOut);
			// System.out.println ("WORK ORDER");
			// System.out.println (workOrderOut);
		} catch (IOException e) {
			System.out.println("IO Error:" + e.getStackTrace()
					+ e.getLocalizedMessage());
			e.printStackTrace();
		} catch (InterruptedException e) {
			System.out.println("Interrupted Error:" + e.getStackTrace());
			e.printStackTrace();
		}

	}

}
